Subject: RE: [Simple] -05 MESSAGE and Expires header

From: [email-masked]
Date: Mon, 22 Jul 2002 12:42:44 +0300

> -----Original Message-----
> From: ext Jonathan Rosenberg [mailto:[email-masked]]
> Sent: Thursday, July 18, 2002 5:25 AM
> To: Adam Roach
> Cc: Ben Campbell; Bobby Sardana; Vijay K. Gurbani; Tan 
> Ya-Ching ICMN PG
> U ID A 1; [email-masked]
> Subject: Re: [Simple] -05 MESSAGE and Expires header
> 
> 
> Expires is method specific, since its precise interpretation 
> is method 
> specific. The general notion is that it indicates a lifetime of 
> something; a point after which the thing is no longer valid. I think 
> that this more genearl definition is an exact match to our need here, 
> and the current Expires text is an appropriate instantiation 
> of it for 
> MESSAGE.

How do you interpret "the thing is no longer valid" to mean immediate delivery?

In 3261, it says about Priority header "For example, it may be factored into decisions about call routing and acceptance". So, if you want your message to be delivered immediately, you are playing with the routing, hence Priority header.

Message saying "Leaving for lunch now" with Expires 0 to me says that this message expires immediately (just like a SUBSCRIBE with expires 0 means this subscription expires immediately), not that it requires immediate delivery. It also means "don't bother replying, I've left already".

I think using expires for routing decisions is a hack.

The questions are: 

- Is Priority header used for user interface purposes only, or for routing decisions as well?
- When is a message urgent but does not require immediate delivery?

If I need the business presentation by 10pm and its 7am, then the message does not require immediate delivery nor is it urgent, but if its 9:55pm, then its urgent and certainly needs immediate delivery.

Regards,
Hisham

> 
> I believe that priority is quite different. A message can be for 
> immediate delivery, and be either urgent ("my house is on 
> fire") or not 
> ("leaving now for lunch"). A message can be OK for storage (some 
> non-zero expires) and be urgent ("I need that business 
> presentation by 
> 10pm!") or non-urgent ("Did you see that movie"). The fact that two 
> things can be used orthogonally is a sign that they are, in fact, two 
> different things.
> 
> I strongly support keeping Expires as currently defined.
> 
> -Jonathan R.
> 
> Adam Roach wrote:
> > Personally, I think the "Expires" handling is sufficient
> > and unambiguious.
> > 
> > The use of "Priority" would be inappropriate. High priority
> > items don't necessarily have a high urgency -- and what you're
> > trying to communicate here is urgency, not priority.
> > 
> > However, I'd take a different tact: this is really a disposition
> > for the message.
> > 
> > In the final equasion, though, I think it's all a moot point,
> > since "Expires: 0" works just fine.
> > 
> > /a
> > 
> > 
> >>-----Original Message-----
> >>From: Ben Campbell [mailto:[email-masked]]
> >>Sent: Tuesday, July 16, 2002 18:24
> >>To: Bobby Sardana
> >>Cc: Vijay K. Gurbani; Tan Ya-Ching ICM N PG U ID A 1;
> >>[email-masked]
> >>Subject: Re: [Simple] -05 MESSAGE and Expires header
> >>
> >>
> >>So, for all that have commented on this thread, is the 
> description of 
> >>Expires in RFC 3261 sufficient? If so, we can fix this by simply 
> >>dropping the sentence about "Expires:0".
> >>
> >>Or do you think the MESSAGE draft needs to contain additional 
> >>language 
> >>concerning "Priority"?
> >>
> >>Bobby Sardana wrote:
> >>
> >>>I'll cast my vote for the Priority header. Expires: 0 
> >>
> >>somehow implies 
> >>
> >>>that the message needs to be dropped.
> >>>
> >>>regards,
> >>>
> >>>Bobby Sardana.
> >>>[email-masked]
> >>>
> >>>Ben Campbell wrote:
> >>>
> >>>
> >>>>Vijay K. Gurbani wrote:
> >>>>
> >>>>>Tan Ya-Ching ICM N PG U ID A 1 wrote:
> >>>>>
> >>>>>
> >>>>>>Vijay,
> >>>>>>
> >>>>>>It is stated in RFC 3261 section 20.19 Expires that :
> >>>>>>"The precise meaning of this (header) is method dependant".
> >>>>>
> >>>>>
> >>>>>Agreed.
> >>>>>
> >>>>>
> >>>>>>The use of the Expires header in MESSAGE is as it is 
> >>>>>
> >>defined in -05.
> >>
> >>>>>>It has
> >>>>>>only one meaning, so there is no overloading.
> >>>>>
> >>>>>
> >>>>>That is debatable; good thing about ASCII protocols is 
> >>>>
> >>that they are
> >>
> >>>>>self describing.  Thus, having a "Priority: Urgent" is far more
> >>>>>preferable to overloading "Expires: 0" to mean immediate 
> >>>>
> >>handling.
> >>
> >>>>>"Priority: Urgent" in this case makes it far more easy to figure
> >>>>>out what is going on.
> >>>>>
> >>>>>- vijay
> >>>>>
> >>>>>
> >>>>>
> >>>>>
> >>>>
> >>>>I do not have strong feelings on this one way or another--either
> >>>>approach works for me. I will bow to the will of the 
> >>>
> >>majority. Anyone
> >>
> >>>>else have comments?
> >>>>
> >>>>_______________________________________________
> >>>>simple mailing list
> >>>>[email-masked]
> >>>>http://mailman.dynamicsoft.com/mailman/listinfo/simple
> >>>>
> >>>
> >>>-- 
> >>>___________________________ 
> >>>
> >>>Bobby Sardana |  SEVEN 
> >>>Software Engineer, Engineering  
> >>>___________________________ 
> >>>
> >>>901 Marshall St.
> >>>Redwood City, CA 94063
> >>>650.381.2535 (v)
> >>>650.216.6455 (f)
> >>>[email-masked]
> >>>www.seven.com
> >>>
> >>> 
> >>
> >>
> >>
> >>_______________________________________________
> >>simple mailing list
> >>[email-masked]
> >>http://mailman.dynamicsoft.com/mailman/listinfo/simple
> >>
> > 
> > _______________________________________________
> > simple mailing list
> > [email-masked]
> > http://mailman.dynamicsoft.com/mailman/listinfo/simple
> > 
> 
> 
> -- 
> ---
> Jonathan D. Rosenberg, Ph.D.                72 Eagle Rock Ave.
> Chief Scientist                             First Floor
> dynamicsoft                                 East Hanover, NJ 07936
> [email-masked]                     FAX:   (973) 952-5050
> http://www.jdrosen.net                      PHONE: (973) 952-5000
> http://www.dynamicsoft.com
> 
> _______________________________________________
> simple mailing list
> [email-masked]
> http://mailman.dynamicsoft.com/mailman/listinfo/simple
>

---

From: Ben Campbell <[email-masked]>
Date: Mon, 22 Jul 2002 11:14:06 -0500

> How do you interpret "the thing is no longer valid" to mean immediate delivery?

It is a bit of a stretch, but not a _big_ stretch. I interpret to mean 
that the message is highly perishable.

> - Is Priority header used for user interface purposes only, or for routing decisions as well?

Priority can be used for routing decisions. But, as mentioned in the 
meeting, it should be interpreted as how high a priority the message has 
compared to _other_ messages. In the trivial case, where only one 
message is being processed, priority is meaningless.

> - When is a message urgent but does not require immediate delivery?

Let me step back and paint a broader picture: A store and forward device 
receives a message with Expires:0. It obviously wants to deliver the 
message immediately, but what if it can't? It should then treat the 
message as stale. What does it do with stale messages? That is a matter 
of local policy. But one perfectly reasonable option is to simply drop 
it on the floor.

Now, that behavior makes no sense at all for a high priority message. 
The server wants to deliver that one quickly, but if it can't do so, it 
still needs to ensure the message gets delivered. That is _not_ the 
behavior we are looking for.

For example, my boss might send me a message containing important 
information for a presentation I am to give tomorrow. It is not 
important that I get the message immediately, since the presentation is 
not until tomorrow. It is, however, important that I actuall _get_ the 
message, and that when I look at my queue of a thousand messages, I 
realize that this one is important for me to read.